<?php
/**
 * Model object generated by: Skipper (http://www.skipper18.com)
 * Do not modify this file manually.
 */

namespace App\AbstractModels;

use Illuminate\Database\Eloquent\Model;

abstract class AbstractExam extends Model
{
    /**  
     * Primary key type.
     * 
     * @var string
     */
    protected $keyType = 'bigInteger';
    
    /**  
     * The attributes that should be cast to native types.
     * 
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'created_at' => 'datetime',
        'updated_at' => 'datetime',
        'name' => 'string',
        'base_price' => 'float',
        'result_type_id' => 'integer',
        'exam_type_id' => 'integer'
    ];
    
    /**  
     * The guarded property should contain an array of attributes that you do not want to be mass assignable.
     * 
     * @var array
     */
    protected $guarded = [];
    
    public function examType()
    {
        return $this->belongsTo('\App\ExamType', 'exam_type_id', 'id');
    }
    
    public function resultType()
    {
        return $this->belongsTo('\App\ResultType', 'result_type_id', 'id');
    }
    
    public function demands()
    {
        return $this->belongsToMany('\App\Demand', 'test', 'exam_id', 'demand_id')->withPivot('resultat_id', 'resultat_type', 'id', 'created_at', 'updated_at');
    }
    
    public function insurances()
    {
        return $this->belongsToMany('\App\Insurance', 'exam_price_by_insurance', 'exam_id', 'insurance_id')->withPivot('id', 'price', 'tm', 'gap_tm', 'gap', 'base_price');
    }
}
